VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmUpdateTime 
   BackColor       =   &H00F7F8F8&
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Uhrzeit abgleichen"
   ClientHeight    =   2655
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   3855
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmUpdateTime.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   177
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   257
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton cmdMenu 
      Caption         =   "&Schlieen"
      Height          =   375
      Index           =   1
      Left            =   720
      TabIndex        =   4
      Top             =   2160
      Width           =   1455
   End
   Begin prjSleeMp3.ctlBorderBar ctlBorderBar 
      Height          =   30
      Left            =   120
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   2040
      Width           =   3615
      _ExtentX        =   6376
      _ExtentY        =   53
   End
   Begin VB.ListBox lstStatus 
      BackColor       =   &H00FFFFFF&
      ForeColor       =   &H00000000&
      Height          =   1575
      IntegralHeight  =   0   'False
      Left            =   120
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   360
      Width           =   3615
   End
   Begin VB.CommandButton cmdMenu 
      Caption         =   "&Zeit abrufen"
      Default         =   -1  'True
      Height          =   375
      Index           =   0
      Left            =   2280
      TabIndex        =   0
      Top             =   2160
      Width           =   1455
   End
   Begin MSWinsockLib.Winsock wskConnection 
      Left            =   0
      Top             =   4680
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Label lblStatusInfo 
      BackStyle       =   0  'Transparent
      Caption         =   "Status:"
      ForeColor       =   &H00000000&
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmUpdateTime"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'##################################################
'# @author : Matthias Bartelt                     #
'# @version: 0.0                                  #
'##################################################
'# @info   : Get the time from the internet.      #
'##################################################

'### Variables must be declared
Option Explicit



'##################################################
'###              DECLARATIONS                  ###
'##################################################

'### API
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetSystemTime Lib "kernel32" (lpSystemTime As SYSTEMTIME) As Long

'### Constants
Private Const cSERVER_PORT   As Long = 13
Private Const cSERVER_URL    As String = "time.gov"

'### Constants (System)
Private Const HWND_BROADCAST As Long = &HFFFF&
Private Const WM_TIMECHANGE  As Long = &H1E

'### Types
Private Type SYSTEMTIME
    wYear                    As Integer
    wMonth                   As Integer
    wDayOfWeek               As Integer
    wDay                     As Integer
    wHour                    As Integer
    wMinute                  As Integer
    wSecond                  As Integer
    wMilliseconds            As Integer
End Type



'##################################################
'###                  EVENTS                    ###
'##################################################

Private Sub Form_Load()
'### @info: If somebody create a instance of this form

'Ignore all errors
On Error Resume Next

End Sub

Private Sub cmdMenu_Click(Index As Integer)
'### @info: Check what button was pressed

'Ignore all errors
On Error Resume Next

    'Chech the button
    Select Case (Index)
        Case 0 'Get time
            'Clear the list
            Call lstStatus.Clear
            'Disable the button
            Let cmdMenu(0).Enabled = False
            'Get the internet time
            Call sGetTime
        Case 1 'Abort
            'Close the connection
            If Not (wskConnection.State = sckClosed) Then Call wskConnection.Close
            'Close this form
            Call Unload(Me)
    End Select
    
End Sub

Private Sub wskConnection_Close()
'### @info: Close the connection

'Ignore all errors
On Error Resume Next

    'Close the connection
    Do Until (wskConnection.State = sckClosed)
        'Close it
        wskConnection.Close
        DoEvents
    Loop
  
    'Show the status
    Call lstStatus.AddItem("Verbindung geschlossen")
    
    'Enable the button
    Let cmdMenu(0).Enabled = True

End Sub

Private Sub wskConnection_Connect()
'### @info: Connection accepted

'Ignore all errors
On Error Resume Next

    'Show the status
    Call lstStatus.AddItem("Verbindung hergestellt")

End Sub

Private Sub wskConnection_DataArrival(ByVal bytesTotal As Long)
'### @info: Data is send to this computer

'Ignore all errors
On Error Resume Next

    'Variables
    Dim sData As String
    
    'Get the arrived data
    Call wskConnection.GetData(sData)

    'Show the status
    Call lstStatus.AddItem("Zeitdaten empfangen")

    'Set the new system data
    Call sSetSystemTime(sData)

End Sub

Private Sub wskConnection_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
'### @info: An error occured

'Ignore all errors
On Error Resume Next
    
    'Show the status
    Call lstStatus.AddItem("Es ist ein Fehler aufgetreten")
    
    'Close the connection
    Call wskConnection.Close

End Sub



'##################################################
'###                 METHODS                    ###
'##################################################

Private Sub sGetTime()
'### @info: Get the time from the internet server

'Process the error
On Error GoTo errError

    'Show the status
    Call lstStatus.AddItem("Versuche Verbindung zum Server aufzubauen")
    
    'Set the info and connect
    With wskConnection
        .RemotePort = cSERVER_PORT
        .RemoteHost = cSERVER_URL
        'Connect to the server
        .Connect
    End With

    Exit Sub

'If an error occured
errError:
'Should the error be displayed
If (COption.pOption_ShowErrorInfo) Then _
    Call frmError.sError(CLng(Err.Number), CStr(Err.Description), "frmUpdateTime:sGetTime")
Resume Next

End Sub

Private Sub sSetSystemTime(ByRef sRecivedString As String)
'### @info: Set the system time by the recived string

'Process the error
On Error GoTo errError

    'Variables
    Dim nTime    As SYSTEMTIME
    Dim sParts() As String

    'Split the data
    If (InStr(1, sRecivedString, " ") > 0) Then
        'Split the data
        Let sParts = Split(sRecivedString, " ")
        
        'Check the item
        If (IsDate(sParts(1))) Then
            'Fill the time into the structure
            With nTime
                .wDay = Val(Right(sParts(1), 2))
                .wMonth = Val(Mid(sParts(1), 4, 2))
                .wYear = 2000 + Val(Left(sParts(1), 2))
                .wHour = Val(Left(sParts(2), 2))
                .wMinute = Val(Mid(sParts(2), 4, 2))
                .wSecond = Val(Right(sParts(2), 2))
            End With
        
            'Set the new system time
            Call SetSystemTime(nTime)
            
            'Inform the system that the time has changed
            Call SendMessage(HWND_BROADCAST, WM_TIMECHANGE, 0&, 0&)
            
            'Show the info
            Call lstStatus.AddItem("Systemzeit erfolgreich aktualisiert")
        Else
            'Show the info
            Call lstStatus.AddItem("Ungltige Daten empfangen")
        End If
    Else
        'Show the info
        Call lstStatus.AddItem("Ungltige Daten empfangen")
    End If
    
    Exit Sub

'If an error occured
errError:
'Should the error be displayed
If (COption.pOption_ShowErrorInfo) Then _
    Call frmError.sError(CLng(Err.Number), CStr(Err.Description), "frmUpdateTime:sSetSystemTime")
Resume Next

End Sub
